libzypp: zypp::ZConfig Class Reference

libzypp 17.25.10

Classes | Public Member Functions | Static Public Member Functions | List of all members
zypp::ZConfig Class Reference
Zypp Configuration Options

Interim helper class to collect global options and settings. More...

`#include <ZConfig.h>`

Inheritance diagram for zypp::ZConfig:
[legend]

## Classes
class | Impl
| ZConfig implementation. More...

## Public Member Functions
std::ostream & | about (std::ostream &str) const
| Print some detail about the current libzypp version. More...
Pathname | systemRoot () const
| The target root directory. More...
Pathname | repoManagerRoot () const
| The RepoManager root directory. More...
void | setRepoManagerRoot (const Pathname &root)
| Sets the RepoManager root directory. More...
Arch | systemArchitecture () const
| The system architecture zypp uses. More...
void | setSystemArchitecture (const Arch &arch_r)
| Override the zypp system architecture. More...
void | resetSystemArchitecture ()
| Reset the zypp system architecture to the default. More...
Locale | textLocale () const
| The locale for translated texts zypp uses. More...
void | setTextLocale (const Locale &locale_r)
| Set the preferred locale for translated texts. More...
void | resetTextLocale ()
| Reset the locale for translated texts to the default. More...
Maintain user data
See also User data as transaction id
bool | hasUserData () const
| Whether a (non empty) user data sting is defined. More...
std::string | userData () const
| User defined string value to be passed to log, history, plugins... More...
bool | setUserData (const std::string &str_r)
| Set a new userData string. More...
Pathname | repoCachePath () const
| Path where the caches are kept (/var/cache/zypp) More...
void | setRepoCachePath (const Pathname &path_r)
| Set a new path as the default repo cache path. More...
Pathname | pubkeyCachePath () const
| Path where the pubkey caches. More...
Pathname | repoMetadataPath () const
| Path where the repo metadata is downloaded and kept (repoCachePath()/raw). More...
void | setRepoMetadataPath (const Pathname &path_r)
| Set a new path as the default repo cache path. More...
Pathname | repoSolvfilesPath () const
| Path where the repo solv files are created and kept (repoCachePath()/solv). More...
void | setRepoSolvfilesPath (const Pathname &path_r)
| Set a new path as the default repo cache path. More...
Pathname | repoPackagesPath () const
| Path where the repo packages are downloaded and kept (repoCachePath()/packages). More...
void | setRepoPackagesPath (const Pathname &path_r)
| Set a new path as the default repo cache path. More...
Pathname | configPath () const
| Path where the configfiles are kept (/etc/zypp). More...
Pathname | knownReposPath () const
| Path where the known repositories .repo files are kept (configPath()/repos.d). More...
Pathname | knownServicesPath () const
| Path where the known services .service files are kept (configPath()/services.d). More...
Pathname | needrebootFile () const
| Path of the default needreboot config file (configPath()/needreboot). More...
Pathname | needrebootPath () const
| Path where the custom needreboot config files are kept (configPath()/needreboot.d). More...
Pathname | varsPath () const
| Path containing custom repo variable definitions (configPath()/vars.d). More...
bool | repo_add_probe () const
| Whether repository urls should be probed. More...
unsigned | repo_refresh_delay () const
| Amount of time in minutes that must pass before another refresh. More...
LocaleSet | repoRefreshLocales () const
| List of locales for which translated package descriptions should be downloaded. More...
bool | repoLabelIsAlias () const
| Whether to use repository alias or name in user messages (progress, exceptions, ...). More...
void | repoLabelIsAlias (bool yesno_r)
| Whether to use repository alias or name in user messages (progress, exceptions, ...). More...
long | download_max_concurrent_connections () const
| Maximum number of concurrent connections for a single transfer. More...
long | download_min_download_speed () const
| Minimum download speed (bytes per second) until the connection is dropped. More...
long | download_max_download_speed () const
| Maximum download speed (bytes per second) More...
long | download_max_silent_tries () const
| Maximum silent tries. More...
long | download_transfer_timeout () const
| Maximum time in seconds that you allow a transfer operation to take. More...
bool | download_use_deltarpm () const
| Whether to consider using a deltarpm when downloading a package. More...
bool | download_use_deltarpm_always () const
| Whether to consider using a deltarpm even when rpm is local. More...
bool | download_media_prefer_download () const
| Hint which media to prefer when installing packages (download vs. More...
bool | download_media_prefer_volatile () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
void | set_download_media_prefer_download (bool yesno_r)
| Set download_media_prefer_download to a specific value. More...
void | set_default_download_media_prefer_download ()
| Set download_media_prefer_download to the configfiles default. More...
Pathname | download_mediaMountdir () const
| Path where media are preferably mounted or downloaded. More...
void | set_download_mediaMountdir (Pathname newval_r)
| Set alternate value. More...
void | set_default_download_mediaMountdir ()
| Reset to zypp.cong default. More...
DownloadMode | commit_downloadMode () const
| Commit download policy to use as default. More...
Signature checking (repodata and packages)
If gpgcheck is `on` (the default) we will either check the signature of repo metadata (packages are secured via checksum in the metadata), or the signature of an rpm package to install if it's repo metadata are not signed or not checked. If gpgcheck is `off`, no checks are performed. The default behavior can be altered by explicitly setting repo_gpgcheck and/or pkg_gpgcheck to perform those checks always (`on`) or never (`off`). Explicitly setting `gpgcheck`, `repo_gpgcheck` or `pkg_gpgcheck` in a repositories .repo file will overwrite the defaults here.
bool | gpgCheck () const
| Turn signature checking on/off (on) More...
TriBool | repoGpgCheck () const
| Check repo matadata signatures (indeterminate - according to gpgcheck) More...
TriBool | pkgGpgCheck () const
| Check rpm package signatures (indeterminate - according to gpgcheck) More...
void | setGpgCheck (bool val_r)
| Change the value. More...
void | setRepoGpgCheck (TriBool val_r)
| Change the value. More...
void | setPkgGpgCheck (TriBool val_r)
| Change the value. More...
void | resetGpgCheck ()
| Reset to the zconfig default. More...
void | resetRepoGpgCheck ()
| Reset to the zconfig default. More...
void | resetPkgGpgCheck ()
| Reset to the zconfig default. More...
Pathname | vendorPath () const
| Directory for equivalent vendor definitions (configPath()/vendors.d) More...
ResolverFocus | solver_focus () const
| The resolvers general attitude when resolving jobs. More...
bool | solver_onlyRequires () const
| Solver regards required packages,patterns,... More...
Pathname | solver_checkSystemFile () const
| File in which dependencies described which has to be fulfilled for a running system. More...
Pathname | solver_checkSystemFileDir () const
| Directory, which may or may not contain files in which dependencies described which has to be fulfilled for a running system. More...
bool | solver_allowVendorChange () const
| Whether vendor check is by default enabled. More...
bool | solver_dupAllowDowngrade () const
| DUP tune: Whether to allow version downgrades upon DUP. More...
bool | solver_dupAllowNameChange () const
| DUP tune: Whether to follow package renames upon DUP. More...
bool | solver_dupAllowArchChange () const
| DUP tune: Whether to allow package arch changes upon DUP. More...
bool | solver_dupAllowVendorChange () const
| DUP tune: Whether to allow package vendor changes upon DUP. More...
bool | solver_cleandepsOnRemove () const
| Whether removing a package should also remove no longer needed requirements. More...
unsigned | solver_upgradeTestcasesToKeep () const
| When committing a dist upgrade (e.g. More...
bool | solverUpgradeRemoveDroppedPackages () const
| Whether dist upgrade should remove a products dropped packages (true). More...
void | setSolverUpgradeRemoveDroppedPackages (bool val_r)
| Set solverUpgradeRemoveDroppedPackages to val_r. More...
void | resetSolverUpgradeRemoveDroppedPackages ()
| Reset solverUpgradeRemoveDroppedPackages to the `zypp.conf` default. More...
Packages which can be installed in different versions at the same time.
This returns the config file values (`names` or `provides:`...). The corresponding packages have the `multiversionInstall` property set. Those packages will be installed using 'rpm -i', so they will not implicitly obsolete other installed versions. See also sat::SolvableType
const std::set< std::string > & | multiversionSpec () const
void | multiversionSpec (std::set< std::string > new_r)
void | clearMultiversionSpec ()
void | addMultiversionSpec (const std::string &name_r)
void | removeMultiversionSpec (const std::string &name_r)
Pathname | locksFile () const
| Path where zypp can find or create lock file (configPath()/locks) More...
bool | apply_locks_file () const
| Whether locks file should be read and applied after start (true) More...
Pathname | update_dataPath () const
| Path where the update items are kept (/var/adm) More...
Pathname | update_scriptsPath () const
| Path where the repo metadata is downloaded and kept (update_dataPath()/). More...
Pathname | update_messagesPath () const
| Path where the repo solv files are created and kept (update_dataPath()/solv). More...
Command to be invoked to send update messages.
std::string | updateMessagesNotify () const
| Command definition for sending update messages. More...
void | setUpdateMessagesNotify (const std::string &val_r)
| Set a new command definition (see update.messages.notify in zypp.conf). More...
void | resetUpdateMessagesNotify ()
| Reset to the zypp.conf default. More...
Options for package installation
target::rpm::RpmInstFlags | rpmInstallFlags () const
| The default target::rpm::RpmInstFlags for ZYppCommitPolicy. More...
Pathname | historyLogFile () const
| Path where ZYpp install history is logged. More...
Pathname | credentialsGlobalDir () const
| Defaults to /etc/zypp/credentials.d. More...
Pathname | credentialsGlobalFile () const
| Defaults to /etc/zypp/credentials.cat. More...
std::string | distroverpkg () const
| Package telling the "product version" on systems not using /etc/product.d/baseproduct. More...

## Static Public Member Functions
static ZConfig & | instance ()
| Singleton ctor. More...
static Arch | defaultSystemArchitecture ()
| The autodetected system architecture. More...
static Locale | defaultTextLocale ()
| The autodetected preferred locale for translated texts. More...

## Plugins
class | RepoManager
class | Impl
RW_pointer< Impl, rw_pointer::Scoped< Impl > > | _pimpl
| Pointer to implementation. More...
Pathname | pluginsPath () const
| Defaults to `/usr/lib/zypp/plugins`. More...
std::string | multiversionKernels () const
| ~ZConfig ()
| Dtor. More...
Pathname | builtinRepoCachePath () const
| The builtin config file value. More...
Pathname | builtinRepoMetadataPath () const
| The builtin config file value. More...
Pathname | builtinRepoSolvfilesPath () const
| The builtin config file value. More...
Pathname | builtinRepoPackagesPath () const
| The builtin config file value. More...
| ZConfig ()
| Default ctor. More...

## Detailed Description

Interim helper class to collect global options and settings.

Use it to avoid hardcoded values and calls to getZYpp() just to retrieve some value like architecture, languages or temppath.

It reads /etc/zypp/zypp.conf, the filename can be overridden by setting the ZYPP_CONF environment variable to a different file.

Note, if you add settings to this file, please follow the following convention:

namespace.settingname

should become

namespace_settingName()

Definition at line 61 of file ZConfig.h.

## Constructor & Destructor Documentation

## ◆ ~ZConfig()

zypp::ZConfig::~ZConfig | ( |  | ) |

Dtor.

Definition at line 828 of file ZConfig.cc.

## ◆ ZConfig()

zypp::ZConfig::ZConfig | ( |  | ) |
| private

Default ctor.

Definition at line 817 of file ZConfig.cc.

## Member Function Documentation

## ◆ instance()

ZConfig & zypp::ZConfig::instance | ( |  | ) |
| static

Singleton ctor.

Definition at line 126 of file Resolver.cc.

## ◆ about()

std::ostream & zypp::ZConfig::about | ( | std::ostream & | str | ) | const

Print some detail about the current libzypp version.

Definition at line 1209 of file ZConfig.cc.

## ◆ systemRoot()

Pathname zypp::ZConfig::systemRoot | ( |  | ) | const

The target root directory.

Returns an empty path if no target is set.

Definition at line 831 of file ZConfig.cc.

## ◆ repoManagerRoot()

Pathname zypp::ZConfig::repoManagerRoot | ( |  | ) | const

The RepoManager root directory.

Returns the same as systemRoot() if not explicitly set.

Definition at line 835 of file ZConfig.cc.

## ◆ setRepoManagerRoot()

void zypp::ZConfig::setRepoManagerRoot | ( | const Pathname & | root | ) |

Sets the RepoManager root directory.

See also
  repoManagerRoot()

Definition at line 841 of file ZConfig.cc.

## ◆ defaultSystemArchitecture()

Arch zypp::ZConfig::defaultSystemArchitecture | ( |  | ) |
| static

The autodetected system architecture.

Definition at line 850 of file ZConfig.cc.

## ◆ systemArchitecture()

Arch zypp::ZConfig::systemArchitecture | ( |  | ) | const

The system architecture zypp uses.

Definition at line 856 of file ZConfig.cc.

## ◆ setSystemArchitecture()

void zypp::ZConfig::setSystemArchitecture | ( | const Arch & | arch_r | ) |

Override the zypp system architecture.

This is useful for test scenarious. But be warned, zypp does not expect the system architecture to change at runtime. So set it at the very beginning before you access any other zypp component.

Definition at line 859 of file ZConfig.cc.

## ◆ resetSystemArchitecture()

void zypp::ZConfig::resetSystemArchitecture | ( |  | ) |
| inline

Reset the zypp system architecture to the default.

Definition at line 105 of file ZConfig.h.

## ◆ defaultTextLocale()

Locale zypp::ZConfig::defaultTextLocale | ( |  | ) |
| static

The autodetected preferred locale for translated texts.

Definition at line 874 of file ZConfig.cc.

## ◆ textLocale()

Locale zypp::ZConfig::textLocale | ( |  | ) | const

The locale for translated texts zypp uses.

Definition at line 880 of file ZConfig.cc.

## ◆ setTextLocale()

void zypp::ZConfig::setTextLocale | ( | const Locale & | locale_r | ) |

Set the preferred locale for translated texts.

Definition at line 883 of file ZConfig.cc.

## ◆ resetTextLocale()

void zypp::ZConfig::resetTextLocale | ( |  | ) |
| inline

Reset the locale for translated texts to the default.

Definition at line 121 of file ZConfig.h.

## ◆ hasUserData()

bool zypp::ZConfig::hasUserData | ( |  | ) | const

Whether a (non empty) user data sting is defined.

Definition at line 898 of file ZConfig.cc.

## ◆ userData()

std::string zypp::ZConfig::userData | ( |  | ) | const

User defined string value to be passed to log, history, plugins...

Definition at line 901 of file ZConfig.cc.

## ◆ setUserData()

bool zypp::ZConfig::setUserData | ( | const std::string & | str_r | ) |

Set a new userData string.

Returns
  `TRUE` if the string was accepted; `FALSE` if the string was rejected due to nonprintable characters or newlines.

Definition at line 904 of file ZConfig.cc.

## ◆ repoCachePath()

Pathname zypp::ZConfig::repoCachePath | ( |  | ) | const

Path where the caches are kept (/var/cache/zypp)

Definition at line 921 of file ZConfig.cc.

## ◆ setRepoCachePath()

void zypp::ZConfig::setRepoCachePath | ( | const Pathname & | path_r | ) |

Set a new path as the default repo cache path.

Definition at line 932 of file ZConfig.cc.

## ◆ pubkeyCachePath()

Pathname zypp::ZConfig::pubkeyCachePath | ( |  | ) | const

Path where the pubkey caches.

Definition at line 927 of file ZConfig.cc.

## ◆ repoMetadataPath()

Pathname zypp::ZConfig::repoMetadataPath | ( |  | ) | const

Path where the repo metadata is downloaded and kept (repoCachePath()/raw).

Definition at line 937 of file ZConfig.cc.

## ◆ setRepoMetadataPath()

void zypp::ZConfig::setRepoMetadataPath | ( | const Pathname & | path_r | ) |

Set a new path as the default repo cache path.

Definition at line 943 of file ZConfig.cc.

## ◆ repoSolvfilesPath()

Pathname zypp::ZConfig::repoSolvfilesPath | ( |  | ) | const

Path where the repo solv files are created and kept (repoCachePath()/solv).

Definition at line 948 of file ZConfig.cc.

## ◆ setRepoSolvfilesPath()

void zypp::ZConfig::setRepoSolvfilesPath | ( | const Pathname & | path_r | ) |

Set a new path as the default repo cache path.

Definition at line 954 of file ZConfig.cc.

## ◆ repoPackagesPath()

Pathname zypp::ZConfig::repoPackagesPath | ( |  | ) | const

Path where the repo packages are downloaded and kept (repoCachePath()/packages).

Definition at line 959 of file ZConfig.cc.

## ◆ setRepoPackagesPath()

void zypp::ZConfig::setRepoPackagesPath | ( | const Pathname & | path_r | ) |

Set a new path as the default repo cache path.

Definition at line 965 of file ZConfig.cc.

## ◆ configPath()

Pathname zypp::ZConfig::configPath | ( |  | ) | const

Path where the configfiles are kept (/etc/zypp).

Definition at line 984 of file ZConfig.cc.

## ◆ knownReposPath()

Pathname zypp::ZConfig::knownReposPath | ( |  | ) | const

Path where the known repositories .repo files are kept (configPath()/repos.d).

Definition at line 990 of file ZConfig.cc.

## ◆ knownServicesPath()

Pathname zypp::ZConfig::knownServicesPath | ( |  | ) | const

Path where the known services .service files are kept (configPath()/services.d).

Definition at line 996 of file ZConfig.cc.

## ◆ needrebootFile()

Pathname zypp::ZConfig::needrebootFile | ( |  | ) | const

Path of the default needreboot config file (configPath()/needreboot).

Definition at line 1002 of file ZConfig.cc.

## ◆ needrebootPath()

Pathname zypp::ZConfig::needrebootPath | ( |  | ) | const

Path where the custom needreboot config files are kept (configPath()/needreboot.d).

Definition at line 1005 of file ZConfig.cc.

## ◆ varsPath()

Pathname zypp::ZConfig::varsPath | ( |  | ) | const

Path containing custom repo variable definitions (configPath()/vars.d).

See also
  zypp::repo::RepoVarExpand Repo variable expander

Definition at line 1008 of file ZConfig.cc.

## ◆ repo_add_probe()

bool zypp::ZConfig::repo_add_probe | ( |  | ) | const

Whether repository urls should be probed.

/ config option repo.add.probe

Definition at line 1028 of file ZConfig.cc.

## ◆ repo_refresh_delay()

unsigned zypp::ZConfig::repo_refresh_delay | ( |  | ) | const

Amount of time in minutes that must pass before another refresh.

Definition at line 1031 of file ZConfig.cc.

## ◆ repoRefreshLocales()

LocaleSet zypp::ZConfig::repoRefreshLocales | ( |  | ) | const

List of locales for which translated package descriptions should be downloaded.

Definition at line 1034 of file ZConfig.cc.

## ◆ repoLabelIsAlias() [1/2]

bool zypp::ZConfig::repoLabelIsAlias | ( |  | ) | const

Whether to use repository alias or name in user messages (progress, exceptions, ...).

True: use alias, false: use name.

Definition at line 1037 of file ZConfig.cc.

## ◆ repoLabelIsAlias() [2/2]

void zypp::ZConfig::repoLabelIsAlias | ( | bool | yesno_r | ) |

Whether to use repository alias or name in user messages (progress, exceptions, ...).

Console applications might prefer to use and display the shorter alias instead of full repository name.

Default: false; i.e. repo label is 'name'

Definition at line 1040 of file ZConfig.cc.

## ◆ download_max_concurrent_connections()

long zypp::ZConfig::download_max_concurrent_connections | ( |  | ) | const

Maximum number of concurrent connections for a single transfer.

Definition at line 1058 of file ZConfig.cc.

## ◆ download_min_download_speed()

long zypp::ZConfig::download_min_download_speed | ( |  | ) | const

Minimum download speed (bytes per second) until the connection is dropped.

Definition at line 1061 of file ZConfig.cc.

## ◆ download_max_download_speed()

long zypp::ZConfig::download_max_download_speed | ( |  | ) | const

Maximum download speed (bytes per second)

Definition at line 1064 of file ZConfig.cc.

## ◆ download_max_silent_tries()

long zypp::ZConfig::download_max_silent_tries | ( |  | ) | const

Maximum silent tries.

Definition at line 1067 of file ZConfig.cc.

## ◆ download_transfer_timeout()

long zypp::ZConfig::download_transfer_timeout | ( |  | ) | const

Maximum time in seconds that you allow a transfer operation to take.

Definition at line 1070 of file ZConfig.cc.

## ◆ download_use_deltarpm()

bool zypp::ZConfig::download_use_deltarpm | ( |  | ) | const

Whether to consider using a deltarpm when downloading a package.

Config option `download.use_deltarpm (true)`

Definition at line 1043 of file ZConfig.cc.

## ◆ download_use_deltarpm_always()

bool zypp::ZConfig::download_use_deltarpm_always | ( |  | ) | const

Whether to consider using a deltarpm even when rpm is local.

This requires download_use_deltarpm being `true`. Config option `download.use_deltarpm.always (false)`

Definition at line 1046 of file ZConfig.cc.

## ◆ download_media_prefer_download()

bool zypp::ZConfig::download_media_prefer_download | ( |  | ) | const

Hint which media to prefer when installing packages (download vs.

CD).

See also
  class media::MediaPriority

Definition at line 1049 of file ZConfig.cc.

## ◆ download_media_prefer_volatile()

bool zypp::ZConfig::download_media_prefer_volatile | ( |  | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 308 of file ZConfig.h.

## ◆ set_download_media_prefer_download()

void zypp::ZConfig::set_download_media_prefer_download | ( | bool | yesno_r | ) |

Set download_media_prefer_download to a specific value.

Definition at line 1052 of file ZConfig.cc.

## ◆ set_default_download_media_prefer_download()

void zypp::ZConfig::set_default_download_media_prefer_download | ( |  | ) |

Set download_media_prefer_download to the configfiles default.

Definition at line 1055 of file ZConfig.cc.

## ◆ download_mediaMountdir()

Pathname zypp::ZConfig::download_mediaMountdir | ( |  | ) | const

Path where media are preferably mounted or downloaded.

Config option `download.media_mountdir (/var/adm/mount)` Needs to be a (writable) directory, otherwise /var/tmp is fallback.

Definition at line 1073 of file ZConfig.cc.

## ◆ set_download_mediaMountdir()

void zypp::ZConfig::set_download_mediaMountdir | ( | Pathname | newval_r | ) |

Set alternate value.

Definition at line 1074 of file ZConfig.cc.

## ◆ set_default_download_mediaMountdir()

void zypp::ZConfig::set_default_download_mediaMountdir | ( |  | ) |

Reset to zypp.cong default.

Definition at line 1075 of file ZConfig.cc.

## ◆ commit_downloadMode()

DownloadMode zypp::ZConfig::commit_downloadMode | ( |  | ) | const

Commit download policy to use as default.

Definition at line 1077 of file ZConfig.cc.

## ◆ gpgCheck()

bool zypp::ZConfig::gpgCheck | ( |  | ) | const

Turn signature checking on/off (on)

Definition at line 1081 of file ZConfig.cc.

## ◆ repoGpgCheck()

TriBool zypp::ZConfig::repoGpgCheck | ( |  | ) | const

Check repo matadata signatures (indeterminate - according to gpgcheck)

Definition at line 1082 of file ZConfig.cc.

## ◆ pkgGpgCheck()

TriBool zypp::ZConfig::pkgGpgCheck | ( |  | ) | const

Check rpm package signatures (indeterminate - according to gpgcheck)

Definition at line 1083 of file ZConfig.cc.

## ◆ setGpgCheck()

void zypp::ZConfig::setGpgCheck | ( | bool | val_r | ) |

Change the value.

Definition at line 1085 of file ZConfig.cc.

## ◆ setRepoGpgCheck()

void zypp::ZConfig::setRepoGpgCheck | ( | TriBool | val_r | ) |

Change the value.

Definition at line 1086 of file ZConfig.cc.

## ◆ setPkgGpgCheck()

void zypp::ZConfig::setPkgGpgCheck | ( | TriBool | val_r | ) |

Change the value.

Definition at line 1087 of file ZConfig.cc.

## ◆ resetGpgCheck()

void zypp::ZConfig::resetGpgCheck | ( |  | ) |

Reset to the zconfig default.

Definition at line 1089 of file ZConfig.cc.

## ◆ resetRepoGpgCheck()

void zypp::ZConfig::resetRepoGpgCheck | ( |  | ) |

Reset to the zconfig default.

Definition at line 1090 of file ZConfig.cc.

## ◆ resetPkgGpgCheck()

void zypp::ZConfig::resetPkgGpgCheck | ( |  | ) |

Reset to the zconfig default.

Definition at line 1091 of file ZConfig.cc.

## ◆ vendorPath()

Pathname zypp::ZConfig::vendorPath | ( |  | ) | const

Directory for equivalent vendor definitions (configPath()/vendors.d)

Definition at line 1014 of file ZConfig.cc.

## ◆ solver_focus()

ResolverFocus zypp::ZConfig::solver_focus | ( |  | ) | const

The resolvers general attitude when resolving jobs.

Definition at line 1093 of file ZConfig.cc.

## ◆ solver_onlyRequires()

bool zypp::ZConfig::solver_onlyRequires | ( |  | ) | const

Solver regards required packages,patterns,...

only

Definition at line 1095 of file ZConfig.cc.

## ◆ solver_checkSystemFile()

Pathname zypp::ZConfig::solver_checkSystemFile | ( |  | ) | const

File in which dependencies described which has to be fulfilled for a running system.

Definition at line 1109 of file ZConfig.cc.

## ◆ solver_checkSystemFileDir()

Pathname zypp::ZConfig::solver_checkSystemFileDir | ( |  | ) | const

Directory, which may or may not contain files in which dependencies described which has to be fulfilled for a running system.

Definition at line 1113 of file ZConfig.cc.

## ◆ solver_allowVendorChange()

bool zypp::ZConfig::solver_allowVendorChange | ( |  | ) | const

Whether vendor check is by default enabled.

Definition at line 1098 of file ZConfig.cc.

## ◆ solver_dupAllowDowngrade()

bool zypp::ZConfig::solver_dupAllowDowngrade | ( |  | ) | const

DUP tune: Whether to allow version downgrades upon DUP.

Definition at line 1101 of file ZConfig.cc.

## ◆ solver_dupAllowNameChange()

bool zypp::ZConfig::solver_dupAllowNameChange | ( |  | ) | const

DUP tune: Whether to follow package renames upon DUP.

Definition at line 1102 of file ZConfig.cc.

## ◆ solver_dupAllowArchChange()

bool zypp::ZConfig::solver_dupAllowArchChange | ( |  | ) | const

DUP tune: Whether to allow package arch changes upon DUP.

Definition at line 1103 of file ZConfig.cc.

## ◆ solver_dupAllowVendorChange()

bool zypp::ZConfig::solver_dupAllowVendorChange | ( |  | ) | const

DUP tune: Whether to allow package vendor changes upon DUP.

Definition at line 1104 of file ZConfig.cc.

## ◆ solver_cleandepsOnRemove()

bool zypp::ZConfig::solver_cleandepsOnRemove | ( |  | ) | const

Whether removing a package should also remove no longer needed requirements.

Definition at line 1106 of file ZConfig.cc.

## ◆ solver_upgradeTestcasesToKeep()

unsigned zypp::ZConfig::solver_upgradeTestcasesToKeep | ( |  | ) | const

When committing a dist upgrade (e.g.

`zypper dup`) a solver testcase is written. It is needed in bugreports, in case something went wrong. This returns the number of testcases to keep on the system. Old cases will be deleted, as new ones are created. Use `0` to write no testcase at all.

Definition at line 1117 of file ZConfig.cc.

## ◆ solverUpgradeRemoveDroppedPackages()

bool zypp::ZConfig::solverUpgradeRemoveDroppedPackages | ( |  | ) | const

Whether dist upgrade should remove a products dropped packages (true).

A new product may suggest a list of old and no longer supported packages (dropped packages). Performing a dist upgrade the solver may try to delete them, even if they do not cause any dependency problem.

Turning this option off, the solver will not try to remove those packages unless they actually do cause dependency trouble. At any time you may use zypper to detect orphaned packages, and do the cleanup manually. Or simply leave them installed as long as you don't need the disk space.

Definition at line 1120 of file ZConfig.cc.

## ◆ setSolverUpgradeRemoveDroppedPackages()

void zypp::ZConfig::setSolverUpgradeRemoveDroppedPackages | ( | bool | val_r | ) |

Set solverUpgradeRemoveDroppedPackages to val_r.

Definition at line 1121 of file ZConfig.cc.

## ◆ resetSolverUpgradeRemoveDroppedPackages()

void zypp::ZConfig::resetSolverUpgradeRemoveDroppedPackages | ( |  | ) |

Reset solverUpgradeRemoveDroppedPackages to the `zypp.conf` default.

Definition at line 1122 of file ZConfig.cc.

## ◆ multiversionSpec() [1/2]

const std::set< std::string > & zypp::ZConfig::multiversionSpec | ( |  | ) | const

Definition at line 1132 of file ZConfig.cc.

## ◆ multiversionSpec() [2/2]

void zypp::ZConfig::multiversionSpec | ( | std::set< std::string > | new_r | ) |

Definition at line 1133 of file ZConfig.cc.

## ◆ clearMultiversionSpec()

void zypp::ZConfig::clearMultiversionSpec | ( |  | ) |

Definition at line 1134 of file ZConfig.cc.

## ◆ addMultiversionSpec()

void zypp::ZConfig::addMultiversionSpec | ( | const std::string & | name_r | ) |

Definition at line 1135 of file ZConfig.cc.

## ◆ removeMultiversionSpec()

void zypp::ZConfig::removeMultiversionSpec | ( | const std::string & | name_r | ) |

Definition at line 1136 of file ZConfig.cc.

## ◆ locksFile()

Pathname zypp::ZConfig::locksFile | ( |  | ) | const

Path where zypp can find or create lock file (configPath()/locks)

Definition at line 1020 of file ZConfig.cc.

## ◆ apply_locks_file()

bool zypp::ZConfig::apply_locks_file | ( |  | ) | const

Whether locks file should be read and applied after start (true)

Definition at line 1138 of file ZConfig.cc.

## ◆ update_dataPath()

Pathname zypp::ZConfig::update_dataPath | ( |  | ) | const

Path where the update items are kept (/var/adm)

Definition at line 1141 of file ZConfig.cc.

## ◆ update_scriptsPath()

Pathname zypp::ZConfig::update_scriptsPath | ( |  | ) | const

Path where the repo metadata is downloaded and kept (update_dataPath()/).

Definition at line 1153 of file ZConfig.cc.

## ◆ update_messagesPath()

Pathname zypp::ZConfig::update_messagesPath | ( |  | ) | const

Path where the repo solv files are created and kept (update_dataPath()/solv).

Definition at line 1147 of file ZConfig.cc.

## ◆ updateMessagesNotify()

std::string zypp::ZConfig::updateMessagesNotify | ( |  | ) | const

Command definition for sending update messages.

Definition at line 1159 of file ZConfig.cc.

## ◆ setUpdateMessagesNotify()

void zypp::ZConfig::setUpdateMessagesNotify | ( | const std::string & | val_r | ) |

Set a new command definition (see update.messages.notify in zypp.conf).

Definition at line 1162 of file ZConfig.cc.

## ◆ resetUpdateMessagesNotify()

void zypp::ZConfig::resetUpdateMessagesNotify | ( |  | ) |

Reset to the zypp.conf default.

Definition at line 1165 of file ZConfig.cc.

## ◆ rpmInstallFlags()

target::rpm::RpmInstFlags zypp::ZConfig::rpmInstallFlags | ( |  | ) | const

The default target::rpm::RpmInstFlags for ZYppCommitPolicy.

Or-combination of target::rpm::RpmInstFlag.

ZConfig.instance().rpmInstallFlags().testFlag( target::rpm::RPMINST_EXCLUDEDOCS );
zypp::ZConfig::ZConfig
ZConfig()
Default ctor.
Definition: ZConfig.cc:817
zypp::target::rpm::RPMINST_EXCLUDEDOCS
@ RPMINST_EXCLUDEDOCS
Definition: RpmFlags.h:40

Definition at line 1170 of file ZConfig.cc.

## ◆ historyLogFile()

Pathname zypp::ZConfig::historyLogFile | ( |  | ) | const

Path where ZYpp install history is logged.

Defaults to /var/log/zypp/history.

See also
  http://en.opensuse.org/Libzypp/Package_History

Definition at line 1174 of file ZConfig.cc.

## ◆ credentialsGlobalDir()

Pathname zypp::ZConfig::credentialsGlobalDir | ( |  | ) | const

Defaults to /etc/zypp/credentials.d.

Definition at line 1180 of file ZConfig.cc.

## ◆ credentialsGlobalFile()

Pathname zypp::ZConfig::credentialsGlobalFile | ( |  | ) | const

Defaults to /etc/zypp/credentials.cat.

Definition at line 1186 of file ZConfig.cc.

## ◆ distroverpkg()

std::string zypp::ZConfig::distroverpkg | ( |  | ) | const

Package telling the "product version" on systems not using /etc/product.d/baseproduct.

On RHEL, Fedora and others the "product version" is determined by the first package providing 'system-release'. This value is not hardcoded in YUM and can be configured with the $distroverpkg variable.

Defaults to 'system-release'.

Definition at line 1194 of file ZConfig.cc.

## ◆ pluginsPath()

Pathname zypp::ZConfig::pluginsPath | ( |  | ) | const

Defaults to `/usr/lib/zypp/plugins`.

Definition at line 1199 of file ZConfig.cc.

## ◆ multiversionKernels()

std::string zypp::ZConfig::multiversionKernels | ( |  | ) | const

Defaults to a empty string, if no keep spec is defined no kernels are removed

Definition at line 1202 of file ZConfig.cc.

## ◆ builtinRepoCachePath()

Pathname zypp::ZConfig::builtinRepoCachePath | ( |  | ) | const
| private

The builtin config file value.

Definition at line 970 of file ZConfig.cc.

## ◆ builtinRepoMetadataPath()

Pathname zypp::ZConfig::builtinRepoMetadataPath | ( |  | ) | const
| private

The builtin config file value.

Definition at line 973 of file ZConfig.cc.

## ◆ builtinRepoSolvfilesPath()

Pathname zypp::ZConfig::builtinRepoSolvfilesPath | ( |  | ) | const
| private

The builtin config file value.

Definition at line 976 of file ZConfig.cc.

## ◆ builtinRepoPackagesPath()

Pathname zypp::ZConfig::builtinRepoPackagesPath | ( |  | ) | const
| private

The builtin config file value.

Definition at line 979 of file ZConfig.cc.

## Friends And Related Function Documentation

## ◆ RepoManager

friend class RepoManager
| friend

Definition at line 552 of file ZConfig.h.

## ◆ Impl

friend class Impl
| friend

Definition at line 563 of file ZConfig.h.

## Member Data Documentation

## ◆ _pimpl

RW_pointer<Impl, rw_pointer::Scoped<Impl> > zypp::ZConfig::_pimpl
| private

Pointer to implementation.

Definition at line 567 of file ZConfig.h.

The documentation for this class was generated from the following files:

- zypp/ZConfig.h
- zypp/solver/detail/Resolver.cc
- zypp/ZConfig.cc